build.sh 9.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237
  1. #!/bin/bash
  2. # (c) 2014-2015 Freifunk Paderborn <maschinenraum@paderborn.freifunk.net>
  3. #
  4. # This script builds the firmware by the environment variables given, the
  5. # first two being mandatory:
  6. #
  7. # BASE = Gluon Version (tag or commit, i.e. v2014.4)
  8. # BRANCH = Firmware Branch (stable/testing/experimental)
  9. # SITE = site repository to use
  10. # SITE_ID = specific site repository commit-id (leave blank to use HEAD)
  11. # VERSION = the version tag (can only be empty if BRANCH=experimental)
  12. # BUILD_TS = build timestamp (format: %Y-%m-%d %H:%M:%S)
  13. # BROKEN = 0 (default) or 1, build the untested hardware model firmwares, too
  14. # MAKEJOBS = number of compiler processes running in parallel (default: number of CPUs/Cores)
  15. # TARGETS = a space separated list of target platforms (if unset, all platforms will be build)
  16. # PRIORITY = determines the number of day a rollout phase should last at most
  17. # VERBOSE = 0 (default) or 1, call the make commands with 'V=s' to see actual errors better
  18. #
  19. function get_all_supported_platforms()
  20. {
  21. local buffer;
  22. for val in $(ls ${1}) ; do
  23. [ -d "./${1}/${val}" ] || continue
  24. buffer="${buffer} ${val}"
  25. done
  26. echo ${buffer}
  27. }
  28. if [ "_$BRANCH" == "_" ]; then
  29. echo "Please specify BRANCH environment variable." >&2
  30. exit 1
  31. fi
  32. if [ "_$BASE" == "_" ]; then
  33. echo "Please specify BASE environment variable (Gluon, i.e. 'v2014.3' or commit-id)." >&2
  34. exit 1
  35. fi
  36. if [ "${BRANCH}" != "experimental" -a "${BASE}" == "HEAD" ] ; then
  37. echo "HEAD is not an allowed BASE-identifier for non-experimental builds." >&2
  38. echo "Either use a tagged commit or the commit-SHA itself." >&2
  39. exit 1
  40. fi
  41. if [ "_$VERSION" == "_" -a "$BRANCH" != "experimental" ]; then
  42. echo "Please specify VERSION environment variable (not necessary for experimental branch)." >&2
  43. exit 1
  44. fi
  45. MY_DIR=$(dirname $0)
  46. MY_DIR=$(readlink -f "$MY_DIR")
  47. CODE_DIR="src"
  48. OUTPUT_DIR="${MY_DIR}/output"
  49. BUILD_INFO_FILENAME="build-info.txt"
  50. VERSIONS_INFO_DIR="versions"
  51. pushd $MY_DIR > /dev/null
  52. [ "_$BUILD_TS" == "_" ] && export BUILD_TS=$(date +"%Y-%m-%d %H:%M:%S")
  53. . functions.sh
  54. ### CHECK THAT VERSION DOES NOT YET EXISTS
  55. [ -n "$VERSION" -a -x "${VERSIONS_INFO_DIR}/${VERSION}" ] && abort "There exists a version file for '$VERSION' ... you are trying to do something really stupid, aren't you?"
  56. ### INIT /src IF NECESSARY
  57. if [ ! -d "$CODE_DIR" ]; then
  58. info "Code directory does not exist yet - fetching Gluon ..."
  59. git clone https://github.com/freifunk-gluon/gluon.git "$CODE_DIR"
  60. fi
  61. if [ "_${SITE_REPO_FETCH_METHOD}" != "_git" ]; then
  62. SITE_REPO_URL="https://git.c3pb.de/freifunk-pb/site-${SITE}.git"
  63. else
  64. SITE_REPO_URL="git@git.c3pb.de:freifunk-pb/site-${SITE}.git"
  65. fi
  66. ### INIT /src/site IF NECESSARY
  67. if [ -d "$CODE_DIR/site" ]; then
  68. # verify the site-repo is the correct one ($SITE), otherwise delete the repo
  69. pushd "$CODE_DIR/site"
  70. url=$(git remote show origin | awk '/Fetch URL/ { print $3; }')
  71. if [ "$SITE_REPO_URL" != "$url" ]; then
  72. info "The site repository is not the correct one."
  73. if ! git diff-index --quiet HEAD --; then
  74. popd > /dev/null
  75. abort "The site repo is the wrong one but has local modifications, please fix this manually."
  76. fi
  77. # check on the actual branch, not the target one given as parameter
  78. local_branch=$(git branch --list --no-color | awk '/^*/ { print $2; }')
  79. commits=$(git log origin/${local_branch}..HEAD)
  80. if [ -n "$commits" ]; then
  81. popd > /dev/null
  82. abort "The site repo is the wrong one but has unpushed commits, please fix this manually."
  83. fi
  84. # remove the directory without asking further questions
  85. popd > /dev/null
  86. rm -Rf "$CODE_DIR/site" || abort "Failed to remove wrong site-repository."
  87. success "Removed old site directory in order to be able to clone the correct one."
  88. else
  89. popd > /dev/null
  90. fi
  91. fi
  92. if [ ! -d "$CODE_DIR/site" ]; then
  93. info "Site repository does not exist, fetching it ..."
  94. git clone "$SITE_REPO_URL" "$CODE_DIR/site" || abort "Failed to fetch SITE repository."
  95. fi
  96. ### CHECKOUT GLUON
  97. progress "Checking out GLUON '$BASE' ..."
  98. cd $CODE_DIR
  99. # TODO: check if gluon got modified and bail out if necessary
  100. git fetch
  101. if [ "$BASE" = "master" ]; then
  102. git checkout -q origin/master
  103. else
  104. git checkout -q $BASE
  105. fi
  106. [ "$?" -eq "0" ] || abort "Failed to checkout '$BASE' gluon base version, mimimi." >&2
  107. GLUON_COMMIT=$(git rev-list --max-count=1 HEAD)
  108. ### CHECKOUT SITE REPO
  109. progress "Checking out SITE REPO ..."
  110. cd site
  111. # TODO: check if site got modified locally and bail out if necessary
  112. if [ "_${SITE_ID}" == "_" ]; then
  113. # no specific site given - get the most current one
  114. git checkout -q $BRANCH ; git pull
  115. [ "$?" -eq "0" ] || abort "Failed to get newest '$BRANCH' in site repository, mimimi."
  116. else
  117. # fetch site repo updates
  118. git fetch || true
  119. # commit given - use this one
  120. git checkout -q ${SITE_ID} || abort "Failed to checkout requested site commit, mimimi."
  121. fi
  122. SITE_COMMIT=$(git rev-list --max-count=1 HEAD)
  123. cd ..
  124. ### CLEAN
  125. if [ -d "./build/" -a "$BRANCH" != "experimental" ]; then
  126. progress "Cleaning your build environment ..."
  127. make dirclean
  128. fi
  129. ### PREPARE
  130. progress "Preparing the build environment (make update) ..."
  131. make update
  132. [ "$?" -eq "0" ] || abort "Failed to update the build environment, mimimi."
  133. # determine VERSION for BRANCH=experimental if it is not set
  134. if [ "${BRANCH}" == "experimental" -a -z "${VERSION}" ] ; then
  135. default_release_pattern=$( awk -F" := " '/^DEFAULT_GLUON_RELEASE/ { gsub("shell ", "", $2); print $2; }' ./site/site.mk )
  136. VERSION=$(eval echo ${default_release_pattern})
  137. info "EXPERIMENTAL FIRMWARE: using version tag '$VERSION'"
  138. fi
  139. # set reasonable defaults for unset environment variables
  140. [ -n "${BROKEN}" ] || BROKEN=0
  141. [ -n "${MAKEJOBS}" ] || MAKEJOBS=$(grep -c "^processor" /proc/cpuinfo)
  142. [ -n "${TARGETS}" ] || TARGETS=$(get_all_supported_platforms "./targets")
  143. [ -n "${PRIORITY}" ] || PRIORITY=0
  144. MAKE_PARAM=""
  145. [ "_$VERBOSE" = "_1" ] && MAKE_PARAM="${MAKE_PARAM} V=s"
  146. # we are now ready to produke the firmware images, so let's "save" our state
  147. build_info_path="${OUTPUT_DIR}/${BRANCH}/${BUILD_INFO_FILENAME}"
  148. progress "Saving build information to: ${build_info_path}"
  149. [ -n "${build_info_path}" -a -f "${build_info_path}" ] && rm -f ${build_info_path}
  150. mkdir -p $(dirname ${build_info_path})
  151. [ "$?" -eq "0" ] || abort "Unable to create output directory: $(dirname ${build_info_path})"
  152. touch $(dirname ${build_info_path})
  153. [ "$?" -eq "0" ] || abort "Cannot create build information file: ${build_info_path}"
  154. echo "VERSION=${VERSION}" >> ${build_info_path}
  155. echo "GLUON=${GLUON_COMMIT} # ${BASE}" >> ${build_info_path}
  156. echo "BRANCH=${BRANCH}" >> ${build_info_path}
  157. echo "SITE_REPO=${SITE}" >> ${build_info_path}
  158. echo "SITE=${SITE_COMMIT} # ${VERSION}" >> ${build_info_path}
  159. echo "TARGETS=${TARGETS}" >> ${build_info_path}
  160. echo "TS=${BUILD_TS}" >> ${build_info_path}
  161. ### BUILD FIRMWARE
  162. progress "Building the firmware - please stand by!"
  163. for target in ${TARGETS} ; do
  164. # configure build environment for our current target
  165. export GLUON_TARGET="${target}"
  166. gluon_build_env_vars="GLUON_TARGET=\"${target}\" GLUON_BRANCH=\"${BRANCH}\" GLUON_RELEASE=\"${VERSION}\" BROKEN=\"${BROKEN}\""
  167. # prepare build environment for our current target
  168. progress "Preparing build environment for target ${target}."
  169. [ "${BRANCH}" == "experimental" ] || make clean
  170. make -j ${MAKEJOBS} prepare-target${MAKE_PARAM}
  171. # need to have a toolchain for the particular target
  172. progress "Building toolchain for target ${target}."
  173. make -j ${MAKEJOBS} toolchain/install${MAKE_PARAM}
  174. [ "$?" -eq "0" ] || abort "Unable to build toolchain for target. Aborting."
  175. # now we can start building the images for the target platform
  176. progress "Building FFPB-flavoured Gluon firmware for target ${target}. You'd better go and fetch some c0ffee!"
  177. make_targets="prepare"
  178. eval "${gluon_build_env_vars} faketime \"$BUILD_TS\" make -j ${MAKEJOBS} ${make_targets}${MAKE_PARAM}"
  179. [ "$?" -eq "0" ] || abort "Failed to build firmware for target-platform ${target}."
  180. # finally compile the firmware binaries
  181. progress "Compiling binary firmware images."
  182. faketime "$BUILD_TS" make images${MAKE_PARAM}
  183. [ "$?" -eq "0" ] || abort "Failed to assemble images for target-platform ${target}."
  184. done
  185. cd ..
  186. # compress all binaries into 7z archive
  187. progress "Assembling images.7z ..."
  188. [ -e "${OUTPUT_DIR}/${BRANCH}/images.7z" ] && rm "${OUTPUT_DIR}/${BRANCH}/images.7z"
  189. 7z a "${OUTPUT_DIR}/${BRANCH}/images.7z" ${CODE_DIR}/images/sysupgrade/*.bin ${CODE_DIR}/images/factory/*.bin || abort "Failed to assemble images (did you install p7zip-full?)."
  190. # generate, franken-merge, and copy manifests
  191. progress "Generating and copying manifest ..."
  192. pushd $CODE_DIR
  193. GLUON_TARGET="ar71xx-generic" GLUON_BRANCH=$BRANCH make manifest || abort "Failed to generate the manifest, try running 'make manifest' in '$CODE_DIR' directory manually."
  194. popd
  195. cp "${CODE_DIR}/images/sysupgrade/${BRANCH}.manifest" "${OUTPUT_DIR}/${BRANCH}/"
  196. # Saving a copy of the build info file as reference
  197. progress "Building a greater and brighter firmware finished successfully. Saving build information at: ${VERSIONS_INFO_DIR}/${VERSION}"
  198. cp -p "${build_info_path}" "${VERSIONS_INFO_DIR}/${VERSION}"
  199. # The end. Finally.
  200. success "We're done, go and enjoy your new firmware in ${OUTPUT_DIR}/${BRANCH}!"
  201. popd > /dev/null